<html xmlns:py="http://genshi.edgewall.org/" xmlns:xi="http://www.w3.org/2001/XInclude" py:strip="">

<py:def function="page_title">Developing phpMyAdmin</py:def>

<div py:match="content" id="body">

<h2>Developing phpMyAdmin</h2>

<p>
phpMyAdmin is (as the name says) written in PHP and uses MySQL. Besides this,
we also need people skilled in HTML, JavaScript and CSS, as these are parts
which make our user interface. You don't have to be expert in all these areas
- even knowing only one of them, you can still provide substantial help in
creating or debugging some features.
</p>

<p>
For storing our code we use <a href="http://git-scm.com/">Git</a>.
If you don't know it, you can get some basic facts in <a
href="http://en.wikipedia.org/wiki/Git_software">Wikipedia</a> or
reference in the comprehensive book <a href="http://progit.org/">Pro Git</a>.
</p>

<p>
You can find more information for developers on our 
<a href="http://wiki.phpmyadmin.net/pma/Development">wiki</a>.
</p>

<h3>Contributing code</h3>
<p>
Once you have coded an improvement and you are ready to submit it to us,
please use our <a
href="https://sourceforge.net/tracker/?group_id=23067&amp;atid=377410">patch
tracker</a>, where developers will pick up your contributions or guide you
through improving the patch.
</p>

<h3>Simple tasks to start</h3>
<p>
If you are looking for some simple task where you can start, check out
our wiki page with <a href="http://wiki.phpmyadmin.net/pma/Tasks_for_junior_developers">junior
jobs</a> where you can find some tips where to look.
</p>

<h3>Source Code Repository</h3>
<xi:include href="_gitdl.tpl" />

<p>
You are most likely interested in the <code>phpmyadmin</code> repository, which
contains phpMyAdmin itself.
</p>

<p>
Full list of repositories include:
</p>

<dl class="cvslist">
<dt>phpmyadmin</dt><dd>phpMyAdmin code.</dd>
<dt>website</dt><dd>Website code.</dd>
<dt>themes</dt><dd>Custom themes.</dd>
<dt>data</dt><dd>Various project related data (such as logos, T-shirt graphics, etc.).</dd>
<dt>history</dt><dd>Some historical documents (old changelogs or website).</dd>
<dt>planet</dt><dd><a href="http://planet.phpmyadmin.net/">Planet phpMyAdmin</a> configuration.</dd>
<dt>localized_docs</dt><dd>Localized documentation.</dd>
</dl>

<p>
Examples of how to checkout phpMyAdmin code:
</p>

<pre>
#  Latest development version:
git clone git://github.com/phpmyadmin/phpmyadmin.git
</pre>

<h3>Repository Statistics</h3>
<p>Several statistics about the repository are available:</p>
<ul>
<li><a href="http://cia.vc/stats/project/phpmyadmin/">CIA.vc</a></li>
<li><a href="http://www.ohloh.net/projects/phpmyadmin">Ohloh</a></li>
<li><a href="https://github.com/phpmyadmin/">github</a></li>
</ul>

<h3>Coding Standards</h3>
<p>
Standards should be obeyed in all cases when possible. Generated content
should be valid XHTML 1.0 and CSS. PHP code should match <a
href="http://pear.php.net/manual/en/standards.php">PEAR Coding Standards</a>
and documented using <a href="http://www.phpdoc.org/">phpDocumentator</a>.
More information about coding is available on <a href="http://wiki.phpmyadmin.net/pma/Coding_guidelines">
our wiki</a>.
</p>

<h3>Developer Documentation</h3>

<p>More documentation can be found in the following places:</p>
<ul>
<li><a href="http://wiki.phpmyadmin.net/pma/Development">Developers wiki</a></li>
<li><a href="http://www.phpmyadmin.net/phpdoc/">phpMyAdmin's internals
(autogenerated via phpDocumentator)</a></li>
</ul>


</div>

<xi:include href="_page.tpl" />
</html>

